﻿using System;
using System.Threading;

namespace TestProject
{
    /// <summary>
    /// 핸들 상태에서의 파일명
    /// </summary>
    public class FileNameFromHandleState : IDisposable
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 수동 리셋 이벤트
        /// </summary>
        private ManualResetEvent manualResetEvent;

        /// <summary>
        /// 핸들
        /// </summary>
        private IntPtr handle;

        /// <summary>
        /// 파일명
        /// </summary>
        private string fileName;

        /// <summary>
        /// 반환 값
        /// </summary>
        private bool returnValue;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 핸들 - Handle

        /// <summary>
        /// 핸들
        /// </summary>
        public IntPtr Handle
        {
            get
            {
                return this.handle;
            }
        }

        #endregion
        #region 파일명 - FileName

        /// <summary>
        /// 파일명
        /// </summary>
        public string FileName
        {
            get
            {
                return this.fileName;
            }
            set
            {
                this.fileName = value;
            }
        }

        #endregion
        #region 반환 값 - ReturnValue

        /// <summary>
        /// 반환 값
        /// </summary>
        public bool ReturnValue
        {
            get
            {
                return this.returnValue;
            }
            set
            {
                this.returnValue = value;
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Consturctor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - FileNameFromHandleState(handle)

        /// <summary>
        /// 생성자
        /// </summary>
        /// <param name="handle">핸들</param>
        public FileNameFromHandleState(IntPtr handle)
        {
            this.manualResetEvent = new ManualResetEvent(false);

            this.handle = handle;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 1건 대기하기 - WaitOne(wait)

        /// <summary>
        /// 1건 대기하기
        /// </summary>
        /// <param name="wait">대기</param>
        /// <returns>처리 결과</returns>
        public bool WaitOne(int wait)
        {
            return this.manualResetEvent.WaitOne(wait, false);
        }

        #endregion
        #region 설정하기 - Set()

        /// <summary>
        /// 설정하기
        /// </summary>
        public void Set()
        {
            if(this.manualResetEvent == null)
            {
                return;
            }

            this.manualResetEvent.Set();
        }

        #endregion

        #region 리소스 해제하기 - Dispose()

        /// <summary>
        /// 리소스 해제하기
        /// </summary>
        public void Dispose()
        {
            if(this.manualResetEvent != null)
            {
                this.manualResetEvent.Close();

                this.manualResetEvent = null;
            }
        }

        #endregion
    }
}